gi-gio-2.0.19: Gio bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria (garetxe@gmail.com)
Safe Haskell | None
Language | Haskell2010

GI.Gio.Objects.FilenameCompleter

Contents

- Exported types
- Methods
  - getCompletionSuffix
  - getCompletions
  - new
  - setDirsOnly
- Signals
  - gotCompletionData

Description

Completes partial file and directory names given a partial string by looking in the file system for clues. Can return a list of possible completion strings for widget implementations.

Synopsis

- newtype FilenameCompleter = FilenameCompleter (ManagedPtr FilenameCompleter)
- class GObject o => IsFilenameCompleter o
- toFilenameCompleter :: (MonadIO m, IsFilenameCompleter o) => o -> m FilenameCompleter
- noFilenameCompleter :: Maybe FilenameCompleter
- filenameCompleterGetCompletionSuffix :: (HasCallStack, MonadIO m, IsFilenameCompleter a) => a -> Text -> m Text
- filenameCompleterGetCompletions :: (HasCallStack, MonadIO m, IsFilenameCompleter a) => a -> Text -> m [Text]
- filenameCompleterNew :: (HasCallStack, MonadIO m) => m FilenameCompleter
- filenameCompleterSetDirsOnly :: (HasCallStack, MonadIO m, IsFilenameCompleter a) => a -> Bool -> m ()
- type C_FilenameCompleterGotCompletionDataCallback = Ptr () -> Ptr () -> IO ()
- type FilenameCompleterGotCompletionDataCallback = IO ()
- afterFilenameCompleterGotCompletionData :: (IsFilenameCompleter a, MonadIO m) => a -> FilenameCompleterGotCompletionDataCallback -> m SignalHandlerId
- genClosure_FilenameCompleterGotCompletionData :: FilenameCompleterGotCompletionDataCallback -> IO Closure
- mk_FilenameCompleterGotCompletionDataCallback :: C_FilenameCompleterGotCompletionDataCallback -> IO (FunPtr C_FilenameCompleterGotCompletionDataCallback)
- noFilenameCompleterGotCompletionDataCallback :: Maybe FilenameCompleterGotCompletionDataCallback
- onFilenameCompleterGotCompletionData :: (IsFilenameCompleter a, MonadIO m) => a -> FilenameCompleterGotCompletionDataCallback -> m SignalHandlerId
- wrap_FilenameCompleterGotCompletionDataCallback :: FilenameCompleterGotCompletionDataCallback -> C_FilenameCompleterGotCompletionDataCallback

# Exported types

newtype FilenameCompleter Source #

Memory-managed wrapper type.

Constructors

FilenameCompleter (ManagedPtr FilenameCompleter) |

Instances

GObject FilenameCompleter Source # |
Instance details Defined in GI.Gio.Objects.FilenameCompleter Methods gobjectType :: FilenameCompleter -> IO GType Source #
IsObject FilenameCompleter Source # |
Instance details Defined in GI.Gio.Objects.FilenameCompleter
IsFilenameCompleter FilenameCompleter Source # |
Instance details Defined in GI.Gio.Objects.FilenameCompleter

class GObject o => IsFilenameCompleter o Source #

Type class for types which can be safely cast to `FilenameCompleter`, for instance with `toFilenameCompleter`.

Instances

(GObject a, (UnknownAncestorError FilenameCompleter a :: Constraint)) => IsFilenameCompleter a Source # |
Instance details Defined in GI.Gio.Objects.FilenameCompleter
IsFilenameCompleter FilenameCompleter Source # |
Instance details Defined in GI.Gio.Objects.FilenameCompleter

toFilenameCompleter :: (MonadIO m, IsFilenameCompleter o) => o -> m FilenameCompleter Source #

Cast to `FilenameCompleter`, for types for which this is known to be safe. For general casts, use `castTo`.

noFilenameCompleter :: Maybe FilenameCompleter Source #

A convenience alias for `Nothing` :: `Maybe` `FilenameCompleter`.

# Methods

## getCompletionSuffix

filenameCompleterGetCompletionSuffix Source #

Arguments

:: (HasCallStack, MonadIO m, IsFilenameCompleter a) |
=> a | `completer`: the filename completer.
-> Text | `initialText`: text to be completed.
-> m Text | Returns: a completed string, or `Nothing` if no completion exists. This string is not owned by GIO, so remember to `free` it when finished.

Obtains a completion for `initialText` from `completer`.

## getCompletions

filenameCompleterGetCompletions Source #

Arguments

:: (HasCallStack, MonadIO m, IsFilenameCompleter a) |
=> a | `completer`: the filename completer.
-> Text | `initialText`: text to be completed.
-> m [Text] | Returns: array of strings with possible completions for `initialText`. This array must be freed by `strfreev` when finished.

Gets an array of completion strings for a given initial text.

## new

filenameCompleterNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m FilenameCompleter | Returns: a `FilenameCompleter`.

Creates a new filename completer.

## setDirsOnly

filenameCompleterSetDirsOnly Source #

Arguments

:: (HasCallStack, MonadIO m, IsFilenameCompleter a) |
=> a | `completer`: the filename completer.
-> Bool | `dirsOnly`: a `Bool`.
-> m () |

If `dirsOnly` is `True`, `completer` will only complete directory names, and not file names.

# Signals

## gotCompletionData

type C_FilenameCompleterGotCompletionDataCallback = Ptr () -> Ptr () -> IO () Source #

Type for the callback on the (unwrapped) C side.

type FilenameCompleterGotCompletionDataCallback = IO () Source #

Emitted when the file name completion information comes available.

afterFilenameCompleterGotCompletionData :: (IsFilenameCompleter a, MonadIO m) => a -> FilenameCompleterGotCompletionDataCallback -> m SignalHandlerId Source #

Connect a signal handler for the “`got-completion-data`” signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after filenameCompleter #gotCompletionData callback

genClosure_FilenameCompleterGotCompletionData :: FilenameCompleterGotCompletionDataCallback -> IO Closure Source #

Wrap the callback into a `Closure`.

mk_FilenameCompleterGotCompletionDataCallback :: C_FilenameCompleterGotCompletionDataCallback -> IO (FunPtr C_FilenameCompleterGotCompletionDataCallback) Source #

Generate a function pointer callable from C code, from a `C_FilenameCompleterGotCompletionDataCallback`.

noFilenameCompleterGotCompletionDataCallback :: Maybe FilenameCompleterGotCompletionDataCallback Source #

A convenience synonym for ``Nothing` :: `Maybe` `FilenameCompleterGotCompletionDataCallback``.

onFilenameCompleterGotCompletionData :: (IsFilenameCompleter a, MonadIO m) => a -> FilenameCompleterGotCompletionDataCallback -> m SignalHandlerId Source #

Connect a signal handler for the “`got-completion-data`” signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on filenameCompleter #gotCompletionData callback

wrap_FilenameCompleterGotCompletionDataCallback :: FilenameCompleterGotCompletionDataCallback -> C_FilenameCompleterGotCompletionDataCallback Source #

Wrap a `FilenameCompleterGotCompletionDataCallback` into a `C_FilenameCompleterGotCompletionDataCallback`.